assert( Assister, "Assister not found!")

Assister_Invite = Assister:NewModule("Invite")

function Assister_Invite:OnInitialize()
settingsInvite = Assister:AcquireDBNamespace("Invite")
    Assister:RegisterDefaults("Invite", "profile", {
			["RankInvite"] = true, 
			["ListInvite"] = false,
			["LowRank"] = "Officer",
			["List"] = {},
			["Friends"] = true,
			["on"] = true,
})
Assister.Menu.args.AI = {
	type ="group", 
	name = "AutoInvite",
	desc = "AutoInvite Config",
	args = {
		RankInvite = {
			type ="group",
			name = "RankInvite",
			desc = "RankInvite config",
			args = {
				Use = {
	            type = "toggle",
	            name = "Toggle",
	            desc = "Toggle Rank autoinvite",
	            get = function() return settingsInvite.profile.RankInvite end,
	            set = function() settingsInvite.profile.RankInvite = not settingsInvite.profile.RankInvite end,
				map = { [false] = "No", [true] = "Yes" }
				},
				SetRank = {
	            type = "text",
	            name = "SetRank",
	            desc = "The lowest rank to accept invites from",
	            usage = "<Lowest Rank Here>",
	            get = function() return settingsInvite.profile.LowRank end,
	            set = function(v) settingsInvite.profile.LowRank=v end,
				},
			},
		},
		ListInvite = {
		type ="group",
		name = "ListInvite",
		desc = "ListInvite Config",
		args = {
				Use = {
		        type = "toggle",
				name = "Toggle",
				desc = "Toggle auto invite from specified list",
			    get = function() return settingsInvite.profile.ListInvite end,
			    set = function() settingsInvite.profile.ListInvite = not settingsInvite.profile.ListInvite end,
				map = { [false] = "No", [true] = "Yes" }
				},
				ATL = {
			    type = "text",
			    name = "ATL",
			    desc = "Add someone to auto invite list",
			    usage = "<Name Here>",
				get = false,
			    set = function(v) Assister_Invite:AddName(v) end,
				message = "",
				},
				RFL = {
				type = "text",
		        name = "RFL",
		        desc = "Remove someone to auto invite list",
		        usage = "<Name Here>",
				get = false,
		        set = function(v) Assister_Invite:RemoveName(v) end,
				message = "",
				},
				List = {
				type = "execute",
				name = "List",
				desc = "List AutoInvite people",
				func = function() Assister_Invite:ListInvite() end,
				},
			},
		},
	Friends = {
				type = "toggle",
                name = "Friends",
                desc = "Auto accept invites from friends",
                get = function() return settingsInvite.profile.Friends end,
                set = function(v) settingsInvite.profile.Friends = not settingsInvite.profile.Friends end
	},
	Toggle = {
                type = "toggle",
                name = "Toggle",
                desc = "Toggle the module on and off.",
                get = function() return Assister:IsModuleActive("Invite") end,
                set = function(v) Assister:ToggleModuleActive("Invite") end
            },
	},
}
end

function Assister_Invite:OnEnable()
self:RegisterEvent("PARTY_INVITE_REQUEST", "Invite")
end

--Invite Code
function Assister_Invite:Invite()
if settingsInvite.profile.RankInvite then
local o, g, n
	for  o=1, GuildControlGetNumRanks() do
		g=GuildControlGetRankName(o) 
		if string.find(g, settingsInvite.profile.LowRank) then
			for n=1, GetNumGuildMembers() do
			name,  raid, raidIndex = GetGuildRosterInfo(n);
			if arg1==name and raidIndex<o then
				AcceptGroup()
				StaticPopup_Hide("PARTY_INVITE")
				Assister:Print("Invite automatically accepted from".." "..arg1.." ("..settingsInvite.profile.LowRank..")")
				return
			end
			end
		end
	end	
end
if (settingsInvite.profile.ListInvite) then
local i, m
	for i=1, getn(settingsInvite.profile.List) do
	if arg1==settingsInvite.profile.List[i] then
		AcceptGroup()
		StaticPopup_Hide("PARTY_INVITE")
		Assister:Print("Invite automatically accepted from".." "..arg1)
		return
	end
	end
end
if (settingsInvite.profile.Friends) then
if GetNumFriends() > 0 then
local i, name
for i=1, GetNumFriends() do
name=GetFriendInfo(i)
	if arg1 == name then
		AcceptGroup()
		StaticPopup_Hide("PARTY_INVITE")
		Assister:Print("Invite automatically accepted from".." "..arg1)
		return
	end
end
end
end
end


function Assister_Invite:AddName(newvalue)
	tinsert(settingsInvite.profile.List, newvalue)
	Assister:Print("Now people to automatically accept invites from:")
	for _, v in pairs(settingsInvite.profile.List) do 
		Assister:Print(v)
	end
end

function Assister_Invite:RemoveName(value)
	for k, v in pairs(settingsInvite.profile.List) do 
	if v==value then
	tremove(settingsInvite.profile.List, k)
	Assister:Print("Now people to automatically accept invites from:")
	for _, v in pairs(settingsInvite.profile.List) do 
		Assister:Print(v)
	end
	return
	end
	end
	Assister:Print(value.." not found in list")
end

function Assister_Invite:ListInvite()
	Assister:Print("People to automatically accept invites from:")
	for _, v in pairs(settingsInvite.profile.List) do 
		Assister:Print(v)
	end
end 