assert( Assister, "Assister not found!")

Assister_Summon = Assister:NewModule("Summon")

function Assister_Summon:OnInitialize()
settingsSummon = Assister:AcquireDBNamespace("Summon")
Assister:RegisterDefaults("Summon", "profile", {
			["on"] = true,
			["all"] = false,
			["guild"] = false,
			["friends"] = false,
			["party"] = true,
			["fromlist"] = true,
			["List"] = {}
})
Assister.Menu.args.Summon = {
			type ="group",
			name = "AutoSummon",
			desc = "AutoSummon Config",
			args = {
			AcceptFrom = {
			type="group",
			name = "Accept From",
			desc = "Who to automatically accept summons from",
			args = {
			All = {
				type="toggle",
				name="All",
				desc="Auto-Accept all summons",
				get= function() return settingsSummon.profile.all end,
				set= function() settingsSummon.profile.all = not settingsSummon.profile.all end,
				},
			Guild = {
				type="toggle",
				name="Guild",
				desc="Auto-Accept summons from Guildies",
				get= function() return settingsSummon.profile.guild end,
				set= function() settingsSummon.profile.guild = not settingsSummon.profile.guild end,
				},
			Party = {
				type="toggle",
				name="party",
				desc="Auto-Accept summons from party members",
				get= function() return settingsSummon.profile.party end,
				set= function() settingsSummon.profile.party = not settingsSummon.profile.party end,
				},
			Friends = {
				type="toggle",
				name="Friends",
				desc="Auto-Accept summons from people in your friends list",
				get= function() return settingsSummon.profile.friends end,
				set= function() settingsSummon.profile.friends = not settingsSummon.profile.friends end,
				},
			List = {
				type="group",
				name="List",
				desc="Accept summon from list options",
				args = {
					Toggle = {
					type="toggle",
					name="Toggle",
					desc="Auto-Accept summons from the list",
					get= function() return settingsSummon.profile.fromlist end,
					set= function() settingsSummon.profile.fromlist = not settingsSummon.profile.fromlist end,
					},
					ATL = {
				    type = "text",
				    name = "ATL",
				    desc = "Add someone to auto summon list",
				    usage = "<Name Here>",
					get = false,
				    set = function(v) Assister_Summon:AddName(v) end,
					message = "",
					},
					RFL = {
					type = "text",
			        name = "RFL",
			        desc = "Remove someone to auto summon list",
			        usage = "<Name Here>",
					get = false,
			        set = function(v) Assister_Summon:RemoveName(v) end,
					message = "",
					},
					List = {
					type = "execute",
					name = "List",
					desc = "List AutoSummon people",
					func = function() Assister_Summon:ListSummon() end,
					},
				},
				},
			},
			},
			Toggle = {
                type = "toggle",
                name = "Toggle",
                desc = "Toggle the module on and off.",
                get = function() return Assister:IsModuleActive("Summon") end,
                set = function(v) Assister:ToggleModuleActive("Summon") end,
            },
},
}
end

function Assister_Summon:OnEnable()
self:RegisterEvent("CONFIRM_SUMMON", "Summon")
end

--Summon Code
function Assister_Summon:Accept()
if (not UnitAffectingCombat("player")) then
ConfirmSummon()
Assister:Print("Automatically Summoned by".." "..arg1)
end
end
function Assister_Summon:Summon()
		if settingsSummon.profile.all  then
			Assister_Summon:Accept()
			return
		elseif settingsSummon.profile.party then
			if (GetNumRaidMembers() >0) then
				for i=1, GetNumRaidMembers() do name=GetRaidRosterInfo(i);
					if name==arg1 then
					Assister_Summon:Accept()
					return
					end
				end
			else
				for i=1, GetNumPartyMembers() do
				if arg1==UnitName("Party"..i) then
					Assister_Summon:Accept()
					return
				end
				end
			end
		elseif settingsSummon.profile.friends then
			if GetNumFriends() > 0 then
			local i, name
			for i=1, GetNumFriends() do
			name=GetFriendInfo(i)
				if arg1 == name then
					Assister_Summon:Accept()
					return
				end
			end
			end
		elseif  settingsSummon.profile.guild then
			for n=1, GetNumGuildMembers() do
			name = GetGuildRosterInfo(n);
				if arg1==name then
				Assister_Summon:Accept()
					return
				end
			end
		elseif settingsSummon.profile.fromlist then
			local i, m
			for i=1, getn(settingsSummon.profile.list) do
			if arg1==settingsSummon.profile.list[i] then
				Assister_Summon:Accept()
					return
			end
			end
		end
end

function Assister_Summon:AddName(newvalue)
	tinsert(settingsSummon.profile.List, newvalue)
	Assister:Print("Now people to automatically accept summons from:")
	for _, v in pairs(settingsSummon.profile.List) do 
		Assister:Print(v)
	end
end

function Assister_Summon:RemoveName(value)
	for k, v in pairs(settingsSummon.profile.List) do 
	if v==value then
	tremove(settingsSummon.profile.List, k)
	Assister:Print("Now people to automatically accept summons from:")
	for _, v in pairs(settingsSummon.profile.List) do 
		Assister:Print(v)
	end
	return
	end
	end
	Assister:Print(value.." not found in list")
end

function Assister_Summon:ListSummon()
	Assister:Print("People to automatically accept summons from:")
	for _, v in pairs(settingsSummon.profile.List) do 
		Assister:Print(v)
	end
end 