assert( Assister, "Assister not found!")

Assister_Whisper = Assister:NewModule("Whisper")

function Assister_Whisper:OnInitialize()
settingsWhisper = Assister:AcquireDBNamespace("Whisper")
    Assister:RegisterDefaults("Whisper", "profile", {
			["List"] = {"SimpleComm", "<GA27"},
			["on"] = true,
})
Assister.Menu.args.Whisper = {
			type ="group",
			name = "Whisper",
			desc = "Whisper Config",
			args = {
					AF = {
			            type = "text",
			            name = "AF",
			            desc = "Add a filter to the whispers shown",
			            usage = "<Filter Here>",
						get = false,
			            set = function(k) Assister_Whisper:AddWhisperFilter(k) end,
						message = "",
						},
					RF = {
						type = "text",
			            name = "RF",
			            desc = "Remove a filter to the whispers shown",
			            usage = "<Name Here>",
						get = false,
			            set = function(k) Assister_Whisper:RemoveWhisperFilter(k) end,
						message = "",
						},
					List = {
						type = "execute",
						name = "List",
						desc = "List filters",
						func = function() Assister_Whisper:ListWhisperFilter() end,
						},
					Toggle = {
		                type = "toggle",
		                name = "Toggle",
		                desc = "Toggle the module on and off.",
		                get = function() return Assister:IsModuleActive("Whisper") end,
		                set = function(v) Assister:ToggleModuleActive("Whisper") end,
						},
					}
				}
end

function Assister_Whisper:OnEnable()
self:RegisterEvent("CHAT_MSG_WHISPER", "Whisper")
end

function Assister_Whisper:Whisper()
	if getn(settingsWhisper.profile.List)==0 then RaidWarningFrame:AddMessage(arg2.." : "..arg1, 1, 1, 0) return end
	for i=1, getn(settingsWhisper.profile.List) do 
	if string.find(arg1, settingsWhisper.profile.List[i]) then return end
	end
	RaidWarningFrame:AddMessage(arg2.." : "..arg1, 1, 1, 0)
	return
end 

function Assister_Whisper:AddWhisperFilter(newvalue)
	tinsert(settingsWhisper.profile.List, newvalue)
	Assister:Print("Filter List:")
	for _, v in pairs(settingsWhisper.profile.List) do 
		Assister:Print(v)
	end
end

function Assister_Whisper:RemoveWhisperFilter(value)
	for k, v in pairs(settingsWhisper.profile.List) do 
	if v==value then
	tremove(settingsWhisper.profile.List, k)
	Assister:Print("Filter List:")
	for _, v in pairs(settingsWhisper.profile.List) do 
		Assister:Print(v)
	end
	return
	end
	end
	Assister:Print(value.." not found in list")
end

function Assister_Whisper:ListWhisperFilter()
	Assister:Print("Filter List:")
	for _, v in pairs(settingsWhisper.profile.List) do 
		Assister:Print(v)
	end
end

