assert( Assister, "Assister not found!")

--Options
local tablet = AceLibrary("Tablet-2.0")

--FuBar Plugin
AssisterOptions = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "FuBarPlugin-2.0")
AssisterOptions.name = "FuBar - Assister"
AssisterOptions:RegisterDB("AssisterFubarDB")
 
AssisterOptions.hasNoColor = true
AssisterOptions.hasIcon = "Interface\\AddOns\\Assister\\Icon"
AssisterOptions.defaultMinimapPosition = 180
AssisterOptions.clickableTooltip = false
AssisterOptions.cannotDetachTooltip = true

AssisterOptions.OnMenuRequest = Assister.Menu
local args = AceLibrary("FuBarPlugin-2.0"):GetAceOptionsDataTable(AssisterOptions)
for k,v in pairs(args) do
	if AssisterOptions.OnMenuRequest.args[k] == nil then
		AssisterOptions.OnMenuRequest.args[k] = v
	end
end

--Module
local deuce = Assister:NewModule("Options Menu")
deuce.hasFuBar = IsAddOnLoaded("FuBar") and FuBar
if not deuce.hasFuBar then
	Assister.Menu.args.MB = {
			type = "toggle",
			name = "Minimap",
			desc = "Toggle the minimap button.",
			get = function() return AssisterOptions.minimapFrame and AssisterOptions.minimapFrame:IsVisible() or false end,
			set = function(v) if v then AssisterOptions:Show() else AssisterOptions:Hide() Assister:Print("MiniMap button hidden, type /assister mb to show it again") end end,
			map = {[false] = "Hidden", [true] = "Shown"},
			hidden = function() return IsAddOnLoaded("FuBar") and FuBar and true end
		}
AssisterOptions.title = "Assister"
else
AssisterOptions.hideWithoutStandby = true
AssisterOptions.title = "FuBar - Assister"
end

--      Icon Handling

function AssisterOptions:OnEnable()
	self:SetIcon("Interface\\AddOns\\Assister\\Icon")
end

--      FuBar Methods

function AssisterOptions:OnTooltipUpdate()
	if Assister:IsActive() then
		tablet:SetHint("|cffeda55fCtrl-Alt-Click|r to disable Assister completely.")
	else
		tablet:SetHint("Assister is currently disabled. |cffeda55fClick|r to enable.")
	end
end

function AssisterOptions:OnClick()
	if Assister:IsActive() then
		if IsControlKeyDown() and IsAltKeyDown() then
			Assister:ToggleActive(false)
		end
	else
		Assister:ToggleActive(true)
	end

	self:UpdateTooltip()
end 